; -*- scheme -*-
;
; This is the assembler for scheme
; 

(define (tab) (display "\t"))

(define (vector-append vec item)
  (let ((size (vector-length vec)))
	(vector-resize vec (+ 1 size))
	(vector-set! vec size item)
	vec))

(define (gen-op2 c op arg)
  (vector-append c op)  
  (vector-append c arg))

(define *code* (make-vector 0))

(define (assemble l env)
  (if (null? l) *code*
	(let ((opcode (caar l))
		  (arg (cdar l)))
	  (display "opcode=") (display opcode)
	  (display " arg=") (display arg) (newline)
	  (cond
	   ((eq? :push opcode)
		(print "PUSH")
		(cond
		 ((number? arg) (gen-op2 *code* %push arg))
		 ((symbol? arg) (gen-op2 *code* %pushv arg))
		 (else (error "push: bad arg" arg)))
		)
	   ((eq? :call opcode)
		(print "CALL"))
	   (else (error "bad opcode" opcode)))
	  (assemble (cdr l) env))))
