#ifndef SCM_JC_FWR
#define SCM_JC_FWR	struct _SCM_JC_FWR
#endif

/* Jit machine code compiler */
typedef struct {
  SOBJ 		*icode;		/* vm code */
  int		icp;		/* vm code pointer */
  int 		isize;		/* size of icode */

  SCM_MCode	*mcode;		/* Machine code descriptor */

  void *ncode;			/* native code */
  void *ncp;			/* native code pointer */

  SOBJ 		*lit;		/* literal array */
  int 		nlits;		/* number of literals */
  
  void 		**ref;		/* cross ref: index->code address */
  SCM_JC_FWR	*fwr;		/* forward resolver slot */
  int 		nfwr;		/* number of entries fwr */

  SCM_VM3_PRIM *prim_table;	/* primitive table */
} SCM_JC;

/* proto */
SOBJ 	    scm_vm3_engine_nasm(SOBJ code, SCM_VM3_PRIM *t);
void 	    scm_jc_install_prim_compiler(SCM_VM3_PRIM *t);
