#include "../s.h"
#include <lightning.h>

static jit_insn cbuf[4096];

typedef int (*pif)();

SOBJ add2(SOBJ x, SOBJ y)
{
  printf("add2: %p %p\n", x, y);
}

/* vm registers:
 * SP
 * ENV
 * CONT
 */
#define VM_SP	JIT_R2
#define VM_RET	JIT_RET
#define VM_R0	JIT_V0
#define VM_R1	JIT_V1
#define VM_R2	JIT_V2

void vm_getarg(long dr, long n)
{
  if (n == 0) {
	jit_ldr_l(dr, VM_SP);
  } else {
	jit_ldxi_l(dr, VM_SP, -(n * sizeof(long)));
  }
}

void vm_drop(int n)
{
  jit_subi_l(VM_SP, VM_SP, n * sizeof(long));
}

static void vm_add2()
{
  jit_insn *ref1, *ref2;
		vm_getarg		(VM_R0,			0);
		vm_getarg		(VM_R1,			1);
		jit_andr_l		(VM_R2,			VM_R0,		VM_R1);
ref1 =	jit_bmci_l		(jit_forward(),	VM_R2,		1);
		jit_andi_l		(VM_RET,		VM_R0,		~1);
ref2=	jit_bnoaddr_ui	(jit_forward(),	VM_RET,		VM_R1);

		jit_patch		(ref1);
		jit_prepare		(2);
		jit_pusharg_l	(VM_R0);
		jit_pusharg_l	(VM_R1);
		jit_finish		(add2);

		jit_patch(ref2);
		vm_drop(1);
		jit_str_l		(VM_SP,			VM_RET);
}

static void vm_incr()
{
  jit_insn *ref1, *ref2;

  		vm_getarg		(VM_RET,		0);
ref1 =	jit_bmci_l		(jit_forward(),	VM_RET,		1);
ref2 = 	jit_bnoaddi_ui	(jit_forward(),	VM_RET,		2);
		
		jit_patch		(ref1);
		jit_prepare		(2);
		jit_pusharg_l	(VM_RET);
		jit_pusharg_i	(3);
		jit_finish		(add2);
		jit_patch		(ref2);
		jit_str_l		(VM_SP,			VM_RET);
}

void vm_push



int main(int argc, char *argv[])
{
  int n1, n2;
  jit_insn *ref1, *ref2, *ref3;

  pif add = (pif)(jit_set_ip(cbuf).iptr);
  
  jit_set_ip(cbuf);

  jit_prolog(0);
  vm_incr();
  vm_add2();
  jit_ret();
  jit_flush_code(cbuf, jit_get_ip().ptr);

  add( SCM_MKINUM(10), SCM_MKINUM(20) );
}
