/* -*- tab-width:4; -*- */
/*
 * Machine code
 *
 * $Id: mcode.c,v 1.2 2000/09/28 22:33:09 crad Exp $
 */
#include "s.h"
#include "heap.h"

void scm_mcode_mark(SOBJ obj)
{
  SOBJ *p, *l;
  SCM_MCode *mc = SCM_MCODE(obj);
  p = mc->lit;
  l = p + mc->nlits;
  while(p < l) {
	if (scm_is_pointer_to_heap(*p))  scm_gc_mark(*p);
	p++;
  }
}

void scm_mcode_sweep(SOBJ obj)
{
  SCM_MCode *mc = SCM_MCODE(obj);
  if (mc != NULL) {
	scm_free(mc->code);
	scm_free(mc->lit);
	scm_free(mc);
  }
}

void scm_mcode_print(SOBJ obj, PORT *p)
{
  SCM_MCode *mc = SCM_MCODE(obj);
  if (mc == NULL) {
	port_puts(p, "#<mcode NULL>");
  } else {
	port_puts(p, "#<mcode ");
	port_putx(p, mc);
	port_puts(p, " code=");
	port_putx(p, mc->code);
	port_puts(p, ">");
  }
}

SCM_STRBUF *scm_mcode2str(SCM_STRBUF *sb, SOBJ obj, int raw)
{
  SCM_MCode *mc = SCM_MCODE(obj);
  if (mc != NULL) {
	return(scm_strbuf_concat_sprintf(sb, "#<mcode %p code=%p>",
									 mc, mc->code));
  }
  return(scm_strbuf_concat_str(sb, "#<mcode NULL>"));
}

SOBJ scm_mkmcode(SCM_MCode *mc)
{
  SOBJ new = scm_newcell(SOBJ_T_MCODE);
  SCM_MCODE(new) = mc;
  return(new);
}
