; -*- scheme -*-
;
(if (not (find-module "regex")) (load-library "regex.so"))

(define (vector-grep re v)
  (let ((new (make-vector 0)))
	(do ((i 0 (+ i 1)))
		((>= i (vector-length v)) new)
	  (if (regex::match re (vref v i))
		  (vector-append new (vref v i))))))

(define (cmd->vector cmd)
  (let ((v (make-vector 0))
		(p (make-process :null :pipe :null cmd))
		(s (make-string 0)))
	(while (read-line s (process-output p))
		   (vector-append v (string-copy s)))))

(define (cmd->list cmd)
  (let ((l '())
		(p (make-process :null :pipe :null cmd))
		(s (make-string 0)))
	(while (read-line s (process-output p))
		   (set! l (cons (string-copy s) l)))))

(define (list-grep re l)
  (let ((new '()))
	(for-each (lambda (x) (if (regex::match re x) (set! new (cons x new)))) l)
	new))

(define (file-grep re l)
  (if (null? l)
	  #t
	  (let* ((fname (car l))
			 (file (open-input-file fname))
			 (line (make-string 0))
			 )
		(print (cformat "File: %s" fname))
		(while (read-line line file)
			   (if (regex::match re line)
				   (begin (display fname) (display ":") (print line)))
			   )
		(close-port file)
		(file-grep re (cdr l)))))


(define (open-test l)
  (if (null? l) #t
	  (let ((f (open-input-file (car l)))
			(buf (make-string 0))
			)
		(print (car l)) 
		(while (read-line buf f) (print buf))
		(close-port f)
		(open-test (cdr l)))))

(let ((filelist
'("array.c" "asm.c" "asm.h" "atom.c" "boolean.c" "catch.c"
"chkstack.c" "chr.c" "code.c" "config.h" "cont.c" "cont.h" "dyn.c"
"dyntype.c" "env.c" "file.c" "format.c" "hash.c" "heap.c" "heap.h"
"list.c" "lsym.c" "macro.c" "misc.c" "mkvm.h" "module.c" "number.c"
"number.i" "object.c" "object.h" "pointer.c" "port.c" "port.h"
"prim.i" "prim2.i" "proc.c" "proc.h" "process.c" "regex.c" "s.c" "s.h"
"smain.c" "socket.c" "sproto.h" "stack.h" "str.c" "struct.c"
"struct.h" "sym.c" "thread.c" "tstlib.c" "variable.c" "vm2.c" "vm2.h"
"vm2.i")
))
  (open-test filelist))

;(let ((filelist (list-grep #/\.[chi]$/ (cmd->list "ls"))))
;  (file-grep #/^\/\*[DE]\*\s+/ filelist)
;  )

