#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sched.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <semaphore.h>
#include <signal.h>

#define SCM_DEBUG(x...) { \
  fprintf(stderr, "%s:",__FUNCTION__); fprintf(stderr, ## x); }

void handler(int sig)
{
  SCM_DEBUG("thread=%d sig=%d\n", pthread_self(), sig);
}

void thread(char *msg)
{
  printf("THREAD(%d): %s\n", pthread_self(), msg);
  sleep(20);
  printf("THREAD(%d): terminating\n", pthread_self(), msg);
}

int main()
{
  struct sigaction act;
  pthread_t t1,t2,t3;
  
  SCM_DEBUG("in main\n");

  act.sa_flags = SA_RESTART;
  sigfillset(&act.sa_mask);

  act.sa_handler = handler;
  if (sigaction(SIGPWR, &act, NULL) != 0) {
    perror("sigaction");
    exit(1);
  }
  SCM_DEBUG("creating thread1\n"); pthread_create(&t1, NULL, thread, "#1");
  SCM_DEBUG("creating thread2\n"); pthread_create(&t2, NULL, thread, "#2");
  SCM_DEBUG("creating thread3\n"); pthread_create(&t3, NULL, thread, "#3");
  
  SCM_DEBUG("waiting\n");
  SCM_DEBUG("joining\n");
  pthread_join(t1, NULL);
  pthread_join(t2, NULL);
  pthread_join(t3, NULL);
  SCM_DEBUG("finished\n");
  exit(0);
}
