; Thread test

(load "unix.scm")

(define (tst)
  (thread (lambda () (print "xxx Thread 1: Hello") (sleep 1)))
  (thread (lambda () (print "xxx Thread 2: Hello") (sleep 2)))
  (thread (lambda () (print "xxx Thread 3: Hello") (sleep 3)))
  (thread (lambda () (print "xxx Thread 4: Hello") (sleep 4)))

  (print "*** ALL threads started, waiting 20 secs.")
  (sleep 20)
  (print "*** End of wait"))


(define (tst1)
  (thread (lambda () (print "*** 1 ***")))
  (thread (lambda () (print "*** 2 ***")))
  (thread (lambda () (print "*** 3 ***")))
  #f)

(define (repeat count thunk)
  (if (< count 0) #f
	  (begin (thunk) 
			 (repeat (- count 1) thunk))))


(define (tst-join)
	(let ((t '()))
	  (set! t (thread (lambda ()
						(print "Thread sleeping")
						(sleep 10)
						(print "Thread finishes"))))
	  (display "Main waiting on ") (print t)
	  (thread-wait t)
	  (print "Main terminates")))

(define (lsdir)
  (let ((p (make-process :null :pipe :null "ls" "-al"))
		(str (make-string 0)))
	(while (read-line str (process-output p))
		   (print str))))

(define (tst-sys)
  (let* ((t1 (thread	(lambda () (lsdir))))
		 (t2 (thread	(lambda () (lsdir))))
		 (t3 (thread	(lambda () (lsdir))))
		 (t4 (thread	(lambda () (lsdir))))
		 (t5 (thread	(lambda () (lsdir))))
		 )
	(thread-wait t1)
	(thread-wait t2)
	(thread-wait t3)
	(thread-wait t4)
	(thread-wait t5)))

